/**
 * Discipline A Taste For Blood script.
 * <BR>Copyright (c) Nihilistic Software, Inc. 1998-1999
 *
 * @author YB
 * Modified by MtMagus
 * This is mostly a hacked version of Aura Perception with bits of other stuff thrown in
*/

import java.text.Collator;

public class DisciplineATasteForBlood extends Discipline
{
	private static final String	DISCIPLINE_NAME	= "ATasteForBlood";
	private float	duration = 0;

	// --------------------------------------------------------------------------------------------

	public DisciplineATasteForBlood()
	{
	}

	// --------------------------------------------------------------------------------------------

	public boolean cancast(int level, int casterGuid, int targetGuid, float x, float y, float z, boolean bIsPos)
	{
		if(!CheckCastParameters(level, casterGuid, DISCIPLINE_NAME))
			return(false);

		if(!CheckCastTarget(targetGuid, DISCIPLINE_NAME))
			return(false);

		if((targetThing.GetActorFlags() & THING_AF_NOBLEED) != 0)
		{
			DisplayNoCast("RPG_DISC_NOBLOOD");
			return(false);
		}

		return(true);
	}

	public int cast(int level, int casterGuid, int targetGuid)
	{
		// do sanity checks
		if(!CheckCastParameters(level, casterGuid, DISCIPLINE_NAME))
			return(0);

		if(!CheckCastTarget(targetGuid, DISCIPLINE_NAME))
			return(0);

		// chance of discipline failure
		if(Fizzled(level))
		{
			DisplayFizzle(DISCIPLINE_NAME, level);
			return(0);
		}

		try
		{
			targetThing.AddActorEffectByLevel("ef_disc_atasteforblood", 0, 0, casterGuid, EI_FLAG_DISCIPLINE);
			
			// cast text
			DisplayCast(DISCIPLINE_NAME, level);


			String strFormat = " ";
			String strValue = " ";
			String strType = " ";
			String strDiablerist = " ";
			String strClan = " ";
			String strGen = " ";
			String strBlood = " ";

			switch(targetThing.GetActorType())
			{
				case ACTOR_TYPE_VAMPIRE: 
					strType = "ACTOR_TYPE_VAMPIRE";
					break;
				case ACTOR_TYPE_GHOUL:
					strType = "ACTOR_TYPE_GHOUL";
					break;
				case ACTOR_TYPE_HUMAN:
					strType = "ACTOR_TYPE_HUMAN";
					break;
				case ACTOR_TYPE_MONSTER:
					if((targetThing.GetActorFlags() & THING_AF_LUPINE) != 0)
						strType = "ACTOR_TYPE_LUPINE";
					else
						strType = "ACTOR_TYPE_MONSTER";
					break;
			}

			strDiablerist = targetThing.GetActorAura();

			Collator collator = Collator.getInstance();

			if (collator.compare(strDiablerist,"Diablerist") == 0)
				strDiablerist = "Yes";
			else
				strDiablerist = "No";

			strClan = targetThing.GetActorClan();
			strGen = "" + (int)(targetThing.GetActorStat(ACTOR_STAT_GENERATION));
			strBlood = "" + (int)(targetThing.GetActorStat(ACTOR_STAT_BLOOD));

			switch(level)
			{
				case 0: 
					strValue = "Type: %t";
					strFormat = "%t" + strType;
					CodexConsole.PrintFormatNLS(casterThing.GetGUID(), 0, strValue, strFormat, 0xFFFF00);
					break;
				case 1:
					strValue = "Type: %t Gen: %g";
					strFormat = "%t" + strType + "%g" + strGen;
					CodexConsole.PrintFormatNLS(casterThing.GetGUID(), 0, strValue, strFormat, 0xFFFF00);
					break;
				case 2:
					strValue = "Type: %t Gen: %g Diablerist: %d";
					strFormat = "%t" + strType + "%g" + strGen + "%d" + strDiablerist;
					CodexConsole.PrintFormatNLS(casterThing.GetGUID(), 0, strValue, strFormat, 0xFFFF00);
					break;
				case 3:
					strValue = "Type: %t Gen: %g Diablerist: %d";
					strFormat = "%t" + strType + "%g" + strGen + "%d" + strDiablerist;
					CodexConsole.PrintFormatNLS(casterThing.GetGUID(), 0, strValue, strFormat, 0xFFFF00);

					strValue = "Clan: %c";
					strFormat = "%c" + strClan;
					CodexConsole.PrintFormatNLS(casterThing.GetGUID(), 0, strValue, strFormat, 0xFFFF00);
					break;
				case 4:
					strValue = "Type: %t Gen: %g Diablerist: %d";
					strFormat = "%t" + strType + "%g" + strGen + "%d" + strDiablerist;
					CodexConsole.PrintFormatNLS(casterThing.GetGUID(), 0, strValue, strFormat, 0xFFFF00);

					strValue = "Clan: %c Blood: %B";
					strFormat = "%c" + strClan + "%B" + strBlood;
					CodexConsole.PrintFormatNLS(casterThing.GetGUID(), 0, strValue, strFormat, 0xFFFF00);
					break;
			}

			return(1);
		}
		catch(Exception e)
		{
			CodexConsole.PrintException(e.getMessage() + " in " + DISCIPLINE_NAME + " [cast]");
			return(0);
		}
		catch(Error e)
		{
			CodexConsole.PrintError(e.getMessage() + " in " + DISCIPLINE_NAME + " [cast]");
			return(0);
		}
	}
}

