/**
 * Discipline Blood Dexterity script.
 * <BR>Copyright (c) Nihilistic Software, Inc. 1998-1999
 *
 * @author YB
*/


public class DisciplineBloodDexterity extends Discipline
{
	private static final String	DISCIPLINE_NAME	= "BloodDexterity";

	// --------------------------------------------------------------------------------------------

	public DisciplineBloodDexterity()
	{
	}

	// --------------------------------------------------------------------------------------------

	public int cast(int level, int casterGuid)
	{
		// do sanity checks
		if(!CheckCastParameters(level, casterGuid, DISCIPLINE_NAME))
			return(0);

		try
		{
			int effectGuid = casterThing.FindActorEffect("ef_disc_blooddexterity");
			if(effectGuid != 0)
			{
				casterThing.ExpandActorEffect(effectGuid, BLOODDEXTERITY_DURATIONS[level], false);

				// recast text
				DisplayRecast(DISCIPLINE_NAME, level);
			}
			else
			{
				// start the real effect
				casterThing.AddActorEffectByLevel("ef_disc_blooddexterity", BLOODDEXTERITY_DURATIONS[level], level, casterGuid, EI_FLAG_DISCIPLINE);

				// cast text
				DisplayCast(DISCIPLINE_NAME, level);
			}

			return(1);

		}
		catch(Exception e)
		{
			CodexConsole.PrintException(e.getMessage() + " in " + DISCIPLINE_NAME + " [cast]");
			return(0);
		}
		catch(Error e)
		{
			CodexConsole.PrintError(e.getMessage() + " in " + DISCIPLINE_NAME + " [cast]");
			return(0);
		}
	}

}

