/**
 * Discipline Blood Of Potency script.
 * <BR>Copyright (c) Nihilistic Software, Inc. 1998-1999
 *
 * @author YB
*/


public class DisciplineBloodOfPotency extends Discipline
{
	private static final String	DISCIPLINE_NAME	= "BloodOfPotency";

	// --------------------------------------------------------------------------------------------

	public DisciplineBloodOfPotency()
	{
	}

	// --------------------------------------------------------------------------------------------

	public int cast(int level, int casterGuid)
	{
		// do sanity checks
		if(!CheckCastParameters(level, casterGuid, DISCIPLINE_NAME))
			return(0);

                // Determine Difficulty Rating for using this Discipline
                int diffRating = 6;
            
                // Make Willpower (Manipulation + Wits) Skill Check
                if (!CodexDice.SkillCheckSuccessful(casterThing.GetActorStat(ACTOR_STAT_MANIPULATION) + casterThing.GetActorStat(ACTOR_STAT_WITS), 0, DIE_10_SIDES, diffRating))
                {
                        DisplayFizzle(DISCIPLINE_NAME, level);
                        return(0);
                }

		try
		{
			int effectGuid = casterThing.FindActorEffect("ef_disc_bloodofpotency");
			if(effectGuid != 0)
			{
				casterThing.ExpandActorEffect(effectGuid, BLOODOFPOTENCY_DURATIONS[level], false);

				int effectGuid2 = casterThing.FindActorEffect("ef_disc_bloodofpotency2");
				if(effectGuid2 != 0)
					casterThing.ExpandActorEffect(effectGuid2, BLOODOFPOTENCY_DURATIONS[level], false);

				// recast text
				DisplayRecast(DISCIPLINE_NAME, level);
			}
			else
			{
				// start the real effect
				casterThing.AddActorEffectByLevel("ef_disc_bloodofpotency", BLOODOFPOTENCY_DURATIONS[level], level, casterGuid, EI_FLAG_DISCIPLINE);
				casterThing.AddActorEffectByLevel("ef_disc_bloodofpotency2", BLOODOFPOTENCY_DURATIONS[level], level, casterGuid, EI_FLAG_DISCIPLINE);

				// cast text
				DisplayCast(DISCIPLINE_NAME, level);
			}

			return(1);

		}
		catch(Exception e)
		{
			CodexConsole.PrintException(e.getMessage() + " in " + DISCIPLINE_NAME + " [cast]");
			return(0);
		}
		catch(Error e)
		{
			CodexConsole.PrintError(e.getMessage() + " in " + DISCIPLINE_NAME + " [cast]");
			return(0);
		}
	}
}

