/**
 * Discipline FeralClaws script.
 * <BR>Copyright (c) Nihilistic Software, Inc. 1998-1999
 *
 * @author YB
 * 
 * Edited by Gordon Bergstrm (gordon.bergstrom@telia.com) : 07.18.2000
 * 
 * FeralClaws never expires, except when you change scene.
 * To remove it, cast it again.
*/


public class DisciplineFeralClaws extends Discipline
{
	private static final String	DISCIPLINE_NAME	= "FeralClaws";
	
	// --------------------------------------------------------------------------------------------

	public DisciplineFeralClaws()
	{
	}

	// --------------------------------------------------------------------------------------------

	public int cast(int level, int casterGuid)
	{
		// do sanity checks
		if(!CheckCastParameters(level, casterGuid, DISCIPLINE_NAME))
			return(0);

		SetupWorld(DISCIPLINE_NAME);

		// here we check to see if discipline is running, in that case remove it
		int effectGuid = casterThing.FindActorEffect("ef_disc_feralclaws");
		if(effectGuid != 0)
		{
			casterThing.RemoveActorEffect(effectGuid);
			DisplayStopUse(DISCIPLINE_NAME, level);
			return(1);
		}

		// chance of discipline failure
		if(Fizzled(level))
		{
			DisplayFizzle(DISCIPLINE_NAME, level);
			return(0);
		}
		
		try
		{
			casterThing.AddActorEffectByLevel("ef_disc_feralclaws", 0, level, casterGuid, EI_FLAG_DISCIPLINE);
		
			// cast text
			DisplayCast(DISCIPLINE_NAME, level);
			return(1);
		}
		catch(Exception e)
		{
			CodexConsole.PrintException(e.getMessage() + " in " + DISCIPLINE_NAME + " [cast]");
			return(0);
		}
		catch(Error e)
		{
			CodexConsole.PrintError(e.getMessage() + " in " + DISCIPLINE_NAME + " [cast]");
			return(0);
		}
	}
}

