// Form of the Serpent 
// mostly like ShapeOfTheBeast
// 
// Nick Mossie
// ld@initiated.com

public class DisciplineFormOfTheSerpent extends Discipline
{

    public DisciplineFormOfTheSerpent()
    {
    }

    public int cast(int i, int j)
    {
        if(!CheckCastParameters(i, j, "FormOfTheSerpent"))
            return 0;
        SetupWorld("FormOfTheSerpent");
        if(Fizzled(i))
        {
            DisplayFizzle("FormOfTheSerpent", i);
            return 0;
        }
        try
        {

            int k = casterThing.FindActorEffect("ef_disc_formoftheserpent");
            if(k != 0)
            {
                casterThing.ExpandActorEffect(k, Discipline.SHAPEOFTHEBEAST_DURATIONS[i], false);
                int l = casterThing.FindActorEffect("ef_disc_formoftheserpent2");
                if(l != 0)
                    casterThing.ExpandActorEffect(l, Discipline.SHAPEOFTHEBEAST_DURATIONS[i], false);
                int i1 = casterThing.FindActorEffect("ef_disc_formoftheserpent3");
                if(i1 != 0)
                    casterThing.ExpandActorEffect(i1, Discipline.SHAPEOFTHEBEAST_DURATIONS[i], false);
                DisplayRecast("FormOfTheSerpent", i);
            } else
            {
                casterThing.AddActorEffectByLevel("ef_disc_formoftheserpent", Discipline.SHAPEOFTHEBEAST_DURATIONS[i], i, j, 4);
                casterThing.AddActorEffectByLevel("ef_disc_formoftheserpent2", Discipline.SHAPEOFTHEBEAST_DURATIONS[i], i, j, 4);
                casterThing.AddActorEffectByLevel("ef_disc_formoftheserpent3", Discipline.SHAPEOFTHEBEAST_DURATIONS[i], i, j, 4);
                DisplayCast("FormOfTheSerpent", i);
            }
            return 1;
        }
        catch(Exception exception)
        {
            CodexConsole.PrintException(exception.getMessage() + " in " + "FormOfTheSerpent" + " [cast]");
            return 0;
        }
        catch(Error error)
        {
            CodexConsole.PrintError(error.getMessage() + " in " + "FormOfTheSerpent" + " [cast]");
        }
        return 0;
    }

    private static final String DISCIPLINE_NAME = "FormOfTheSerpent";
}
