/**
 * Discipline Fortitude script.
 * <BR>Copyright (c) Nihilistic Software, Inc. 1998-1999
 *
 * @author YB
 * 
 * Modified by Lord Deviator to include stop and starting foritude and making
 * it last forever.
*/


public class DisciplineFortitude extends Discipline
{
	private static final String	DISCIPLINE_NAME	= "Fortitude";

	// --------------------------------------------------------------------------------------------

	public DisciplineFortitude()
	{
	}

	// --------------------------------------------------------------------------------------------

	public int cast(int level, int casterGuid)
	{
		// do sanity checks
		if(!CheckCastParameters(level, casterGuid, DISCIPLINE_NAME))
			return(0);

		// chance of discipline failure
		if(Fizzled(level))
		{
			DisplayFizzle(DISCIPLINE_NAME, level);
			return(0);
		}

		try
		{
			int effectGuid = casterThing.FindActorEffect("ef_disc_fortitude");
			if(effectGuid != 0)
			{
				casterThing.RemoveActorEffect(effectGuid);
				DisplayStopUse(DISCIPLINE_NAME, level);
			}
			else
			{
				// start the real effect
				// [Lord Deviator] Fortitude is always on
				casterThing.AddActorEffectByLevel("ef_disc_fortitude", 0, level, casterGuid, EI_FLAG_DISCIPLINE);

				// cast text
				DisplayCast(DISCIPLINE_NAME, level);

/**** Old time based code
				casterThing.AddActorEffectByLevel("ef_disc_fortitude", FORTITUDE_DURATIONS[level], level, casterGuid, EI_FLAG_DISCIPLINE);
******/
			}

			return(1);
		}
		catch(Exception e)
		{
			CodexConsole.PrintException(e.getMessage() + " in " + DISCIPLINE_NAME + " [cast]");
			return(0);
		}
		catch(Error e)
		{
			CodexConsole.PrintError(e.getMessage() + " in " + DISCIPLINE_NAME + " [cast]");
			return(0);
		}
	}
}

