/**
 * Discipline Sense The Sin script.
 *   by Serpine (Dave Rosson) - 07/29/2000
 *
 * Based on
 *   Discipline Aura Perception script.
 *   <BR>Copyright (c) Nihilistic Software, Inc. 1998-1999
 *   @author YB
*/


public class DisciplineSenseTheSin extends Discipline
{
	private static final String	DISCIPLINE_NAME	= "SenseTheSin";

	// --------------------------------------------------------------------------------------------

	private float	duration = 0;

	// --------------------------------------------------------------------------------------------

	public DisciplineSenseTheSin()
	{
	}

	// --------------------------------------------------------------------------------------------

	public int cast(int level, int casterGuid, int targetGuid)
	{
		// do sanity checks
		if(!CheckCastParameters(level, casterGuid, DISCIPLINE_NAME))
			return(0);

		if(!CheckCastTarget(targetGuid, DISCIPLINE_NAME))
			return(0);

		// chance of discipline failure
		if(Fizzled(level))
		{
			DisplayFizzle(DISCIPLINE_NAME, level);
			return(0);
		}

		try
		{
			// cast text
			DisplayCast(DISCIPLINE_NAME, level);

			// if the discipline is already running on the target, refresh it
			int effectGuid = targetThing.FindActorEffect("ef_disc_sensethesin");
			if(effectGuid != 0)
				targetThing.RemoveActorEffect(effectGuid);
                       
			// start the effect
			targetThing.AddActorEffectByLevel("ef_disc_sensethesin", EYESOFTHEBEAST_DURATIONS[level], 0, casterGuid, EI_FLAG_DISCIPLINE);

			String strFormat = " ";
			String strValue = " ";
			String strType = " ";
			String strHuma = " ";

			switch(targetThing.GetActorType())
			{
				case ACTOR_TYPE_VAMPIRE: 
					strType = "ACTOR_TYPE_VAMPIRE";
					break;
				case ACTOR_TYPE_GHOUL:
					strType = "ACTOR_TYPE_GHOUL";
					break;
				case ACTOR_TYPE_HUMAN:
					strType = "ACTOR_TYPE_HUMAN";
					break;
				case ACTOR_TYPE_MONSTER:
					if((targetThing.GetActorFlags() & THING_AF_LUPINE) != 0)
						strType = "ACTOR_TYPE_LUPINE";
					else
						strType = "ACTOR_TYPE_MONSTER";
					break;
			}

			strHuma = "" + (int)(targetThing.GetActorStat(ACTOR_STAT_HUMANITY));

			CodexConsole.Print(casterThing.GetGUID(), 0, "Humanity: " + strHuma, 0xFFFF00);
			return(1);
		}
		catch(Exception e)
		{
			CodexConsole.PrintException(e.getMessage() + " in " + DISCIPLINE_NAME + " [cast]");
			return(0);
		}
		catch(Error e)
		{
			CodexConsole.PrintError(e.getMessage() + " in " + DISCIPLINE_NAME + " [cast]");
			return(0);
		}
	}
}

