/**
 * Discipline TheftOfVitae script.
 * <BR>Copyright (c) Nihilistic Software, Inc. 1998-1999
 *
 * @author YB
*/


public class DisciplineTheftOfVitae extends Discipline
{
	private static final String	DISCIPLINE_NAME	= "TheftOfVitae";

	// --------------------------------------------------------------------------------------------

	public DisciplineTheftOfVitae()
	{
	}

	// --------------------------------------------------------------------------------------------

	public boolean cancast(int level, int casterGuid, int targetGuid, float x, float y, float z, boolean bIsPos)
	{
		if(!CheckCastParameters(level, casterGuid, DISCIPLINE_NAME))
			return(false);

		if(!CheckCastTarget(targetGuid, DISCIPLINE_NAME))
			return(false);

		if((targetThing.GetActorFlags() & THING_AF_NOBLEED) != 0)
		{
			DisplayNoCast("RPG_DISC_NOTHEFTOFVITAE1");
			//CodexConsole.PrintNLS(casterGuid, 0, "RPG_DISC_NOTHEFTOFVITAE1", 0xFFFF00);
			return(false);
		}

		if(targetThing.GetActorStat(ACTOR_STAT_BLOOD) < 1.0f)
		{
			DisplayNoCast("RPG_DISC_NOTHEFTOFVITAE2");
			//CodexConsole.PrintNLS(casterGuid, 0, "RPG_DISC_NOTHEFTOFVITAE2", 0xFFFF00);
			return(false);
		}

		return(true);
	}

	public int cast(int level, int casterGuid, int targetGuid)
	{
		// do sanity checks
		if(!CheckCastParameters(level, casterGuid, DISCIPLINE_NAME))
			return(0);

		if(!CheckCastTarget(targetGuid, DISCIPLINE_NAME))
			return(0);

		SetupWorld(DISCIPLINE_NAME);

                // Determine Difficulty Rating for using this Discipline
                int diffRating = 7;
            
                // Make Willpower (Manipulation + Wits) Skill Check
                if (!CodexDice.SkillCheckSuccessful(casterThing.GetActorStat(ACTOR_STAT_MANIPULATION) + casterThing.GetActorStat(ACTOR_STAT_WITS), 0, DIE_10_SIDES, diffRating))
                {
                        DisplayFizzle(DISCIPLINE_NAME, level);
                        return(0);
                }

		try
		{	
			// start the effect
			casterThing.AddActorEffectByLevel("ef_disc_theftofvitae1", 1000, level, casterGuid, EI_FLAG_DISCIPLINE);
			targetThing.AddActorEffectByLevel("ef_disc_theftofvitae2", 1000, level, casterGuid, EI_FLAG_DISCIPLINE);

			// cast text
			DisplayCast(DISCIPLINE_NAME, level);

			return(1);

		}
		catch(Exception e)
		{
			CodexConsole.PrintException(e.getMessage() + " in " + DISCIPLINE_NAME + " [cast]");
			return(0);
		}
		catch(Error e)
		{
			CodexConsole.PrintError(e.getMessage() + " in " + DISCIPLINE_NAME + " [cast]");
			return(0);
		}
	}

}

