/**
 * Region exit script.
 * <BR>Copyright (c) Nihilistic Software, Inc. 1998-1999
 *
 * * 22/07/00 Yith Modified stcommand to add "stcmd [unlock|lock] <location#> <exit#>" command
*/

public class RegionExit extends Codex
{
	private int _exitNumber;
	public static String _params[] = {"Exit number;0"};
	private String		_locationName = "";

	public RegionExit(int exitNumber)
	{
		_exitNumber = exitNumber;
	}
	
	public void beginscene(int clientGuid, int captureID)
	{
		CodexThing playerThing = new CodexThing(clientGuid);
		int locationNum = playerThing.GetLocationNum();
		_locationName = CodexSequence.GetLocationName(locationNum);
	}
	
	public void entered(int guid, int causeGUID, int captureID)
	{
		if(IsPlayerGuid(causeGUID))
		{
			if(!CodexSequence.IsExitClosed(_locationName, _exitNumber))
			{
				CodexSequence.TakeExit(_exitNumber, causeGUID);
			}
			else
			{
				// sound indicating this exit is locked
				new CodexSound("locked_large_02.WAV", 300, 600, 100, 0, 0, causeGUID);

				// display locked message
				CodexConsole.PrintNLS(causeGUID, 0, "GEN_DOORLOCKED");
			}
		}
		
	}
	
	public void stcommand(String blah, int locationIndex, float exitNum, float p1, float p2, float p3)
	{
		if(blah.equalsIgnoreCase("unlock"))
 		{
			String LocationName;
			if (locationIndex>=99)
				LocationName=_locationName;
			else
				LocationName=CodexSequence.GetLocationName(locationIndex);
			if (CodexSequence.IsExitClosed(LocationName, (int)exitNum))
			{
				CodexSequence.OpenExit(LocationName, (int)exitNum);
 				CodexConsole.Print(0, CONSOLEPRINT_FLAG_SERVERCONSOLE, "Unlocked: "+LocationName +" "+(int)exitNum, 0xFFFFFF);
			}
 		}
 		else if (blah.equalsIgnoreCase("lock"))
 		{
			String LocationName;
			if (locationIndex>=99)
				LocationName=_locationName;
			else
				LocationName=CodexSequence.GetLocationName(locationIndex);
			if (!CodexSequence.IsExitClosed(LocationName, (int)exitNum))
			{
				CodexSequence.CloseExit(LocationName, (int)exitNum);
 				CodexConsole.Print(0, CONSOLEPRINT_FLAG_SERVERCONSOLE, "Locked: "+LocationName+" "+(int)exitNum, 0xFFFFFF);
			}
		}
		
	}
	
	public void stcommand2(String blah)
	{
		CodexConsole.Print(0, CONSOLEPRINT_FLAG_SERVERCONSOLE, "Param: " + blah, 0xFFFFFF);	
	}

}
